<?php
	/*
	 *		PSTN Class to Wizard Modal
	 *
	 *
	 */

class PstnWizard
{
	// main variables
	var $nb_lif= 0		;

	var $t1e1  = false	;
	var $types = array()	;
	var $ports = array()	;
	var $start = array()	;

	var $pri_wizard = 'pri-wizard';
	var $bri_wizard = 'bri-wizard';
	var $gsm_wizard = 'gsm-wizard';
	var $fxs_wizard = 'fxs-wizard';
	var $fxo_wizard = 'fxo-wizard';

	var $pstn_header = 'PSTN_header';

	var $ids_array   = array('PSTN_header' => array( 'name'=> 'port_types[]', 'object' => '', 'title' => ''));

	// array title
	var $array_titles = array('group'	=>	PSTN_NAME_DIS	,
				  'ports'	=>	PSTN_PORTS_DIS	,
				  'tones'	=>	PSTN_TONES_DIS	,
				  'country'	=>	PSTN_COUNTRY_DIS,
				  'city'	=>	PSTN_CITY_DIS	,
				  'local'	=>	PSTN_LOCAL_DIS	,
				  'oton'	=>	PSTN_OTON_DIS	,
				  'ntte'	=>	PSTN_NTTE_DIS	,
				  'ptp'		=>	PSTN_PTP_DIS	,
				  't1e1'	=>	PSTN_T1E1_DIS	); 

	// PRI
	var $pri_group	= 'PRI_group'	;
	var $pri_ports	= 'PRI_ports'	;
	var $pri_ntte	= 'PRI_ntte'	;
	var $pri_t1e1	= 'PRI_t1e1'	;
	var $pri_tones	= 'PRI_tones'	;
	var $pri_country= 'PRI_country' ;
	var $pri_city	= 'PRI_city'	;
	var $pri_local	= 'PRI_local'	;
	var $pri_oton	= 'PRI_oton'	;

	var $pri_ids_array = array()	;

	// BRI 
	var $bri_group	= 'BRI_group'	;
	var $bri_ports	= 'BRI_ports'	;
	var $bri_tones	= 'BRI_tones'	;
	var $bri_ptp	= 'BRI_ptp'	;
	var $bri_country= 'BRI_country' ;
	var $bri_city	= 'BRI_city'	;
	var $bri_local	= 'BRI_local'	;
	var $bri_oton	= 'BRI_oton'	;

	var $bri_ids_array = array()	;

	// GSM
	var $gsm_group	= 'GSM_group'	;
	var $gsm_ports	= 'GSM_ports'	;

	var $gsm_ids_array = array()	;

	// FXS	
	var $fxs_group	= 'FXS_group'	;
	var $fxs_ports	= 'FXS_ports'	;
	var $fxs_tones	= 'FXS_tones'	;

	var $fxs_ids_array = array()	;

	// FXO
	var $fxo_group	= 'FXO_group'	;
	var $fxo_ports	= 'FXO_ports'	;
	var $fxo_tones	= 'FXO_tones'	;

	var $fxo_ids_array = array()	;

	function __construct($init = true)
	{
		if ($init)
		{
			$this -> _lifs_info();

			// init PRI ids array
			if (in_array('PRI', $this -> types))
			{
				$this -> pri_ids_array = array( $this -> pri_group 	=> array( 'id' 	=> 'pri-group'	, 'object' => '.value'	, 'title' => $this -> array_titles['group']	),
								$this -> pri_ports	=> array( 'name'=> 'pri-ports[]', 'object' => ''	, 'title' => $this -> array_titles['ports']	),
								$this -> pri_ntte	=> array( 'id'	=> 'pri-ntte'	, 'object' => '.value'	, 'title' => $this -> array_titles['ntte']	),
								$this -> pri_tones	=> array( 'id'	=> 'pri-tones'	, 'object' => '.value'	, 'title' => $this -> array_titles['tones']	),
								$this -> pri_country	=> array( 'id'	=> 'pri-country', 'object' => '.value'	, 'title' => $this -> array_titles['country']	),
								$this -> pri_city	=> array( 'id'	=> 'pri-city'	, 'object' => '.value'	, 'title' => $this -> array_titles['city']	),
								$this -> pri_local	=> array( 'id'	=> 'pri-local'	, 'object' => '.value'	, 'title' => $this -> array_titles['local']	),
								$this -> pri_oton	=> array( 'id'	=> 'pri-oton'	, 'object' => '.value'	, 'title' => $this -> array_titles['oton']	));

				if ($this -> t1e1)
				{
					$t1e1_id = array( $this -> pri_t1e1 => array( 'id' => 'pri-t1e1', 'object' => '.value', 'title' => $this -> array_titles['t1e1']));

					$this -> pri_ids_array = array_merge($this -> pri_ids_array, $t1e1_id);
				}

				$this -> ids_array = array_merge($this -> ids_array, $this -> pri_ids_array);
			}

			// init BRI ids array
			if (in_array('BRI', $this -> types) || in_array('BRI/FXS', $this -> types))
			{
				$this -> bri_ids_array = array( $this -> bri_group 	=> array( 'id' 	=> 'bri-group'	, 'object' => '.value'	, 'title' => $this -> array_titles['group']	),
								$this -> bri_ports	=> array( 'name'=> 'bri-ports[]', 'object' => ''	, 'title' => $this -> array_titles['ports']	),
								$this -> bri_ptp	=> array( 'id'	=> 'bri-ptp'	, 'object' => '.value'	, 'title' => $this -> array_titles['ptp']	),
								$this -> bri_tones	=> array( 'id'	=> 'bri-tones'	, 'object' => '.value'	, 'title' => $this -> array_titles['tones']	),
								$this -> bri_country	=> array( 'id'	=> 'bri-country', 'object' => '.value'	, 'title' => $this -> array_titles['country']	),
								$this -> bri_city	=> array( 'id'	=> 'bri-city'	, 'object' => '.value'	, 'title' => $this -> array_titles['city']	),
								$this -> bri_local	=> array( 'id'	=> 'bri-local'	, 'object' => '.value'	, 'title' => $this -> array_titles['local']	),
								$this -> bri_oton	=> array( 'id'	=> 'bri-oton'	, 'object' => '.value'	, 'title' => $this -> array_titles['oton']	));
				
				$this -> ids_array = array_merge($this -> ids_array, $this -> bri_ids_array); 
			}

			// init GSM ids array
			if (in_array('GSM', $this -> types))
			{
				$this -> gsm_ids_array = array(	$this -> gsm_group 	=> array( 'id' 	=> 'gsm-group'	, 'object' => '.value'	, 'title' => $this -> array_titles['group']	),
								$this -> gsm_ports	=> array( 'name'=> 'gsm-ports[]', 'object' => ''	, 'title' => $this -> array_titles['ports']	));

				$this -> ids_array = array_merge($this -> ids_array, $this -> gsm_ids_array);
			}

			// init FXS ids array
			if (in_array('FXS', $this -> types) || in_array('BRI/FXS', $this -> types))
			{
				$this -> fxs_ids_array = array(	$this -> fxs_group 	=> array( 'id' 	=> 'fxs-group'	, 'object' => '.value'	, 'title' => $this -> array_titles['group']	),
								$this -> fxs_ports	=> array( 'name'=> 'fxs-ports[]', 'object' => ''	, 'title' => $this -> array_titles['ports']	),
								$this -> fxs_tones	=> array( 'id'	=> 'fxs-tones'	, 'object' => '.value'	, 'title' => $this -> array_titles['tones']	));

				$this -> ids_array = array_merge($this -> ids_array, $this -> fxs_ids_array);
			}

			// init FXO ids array
			if (in_array('FXO', $this -> types))
			{
				$this -> fxo_ids_array = array(	$this -> fxo_group 	=> array( 'id' 	=> 'fxo-group'	, 'object' => '.value'	, 'title' => $this -> array_titles['group']	),
								$this -> fxo_ports	=> array( 'name'=> 'fxo-ports[]', 'object' => ''	, 'title' => $this -> array_titles['ports']	),
								$this -> fxo_tones	=> array( 'id'	=> 'fxo-tones'	, 'object' => '.value'	, 'title' => $this -> array_titles['tones']	));

				$this -> ids_array = array_merge($this -> ids_array, $this -> fxo_ids_array);
			} 
		}
	}

	// private
        function _tones ($group, $name, $id, $tones)
	{
                $disabled = (strpos($group, "FXS") !== FALSE) ? 'disabled' : ''; 
                $select = "\t\t\t\t\t\t<select class=\"form-control input-sm\" name=\"$name\" id=\"$id\" $disabled>\n";

                exec('/bin/cat /usr/conf/isgw.tones | /bin/grep "^\[.*\]$" ', $ausgabe);
                foreach ($ausgabe as $value) 
		{
                        if ($tones == "") 
			{
                                if ($value == "[de]") 
				{
                                        $select .= "\t\t\t\t\t\t\t<option value=\"" . $value . "\" selected>" . $value . "</option>\n";
                                } 
				else if ($value != "[general]") 
				{
                                        $select .= "\t\t\t\t\t\t\t<option value=\"" . $value . "\">" . $value . "</option>\n";
                                }
                        } 
			else 
			{
                                if ($value == $tones) 
				{
                                        $select .= "\t\t\t\t\t\t\t<option value=\"" . $value . "\" selected>" . $value . "</option>\n";
                                } 
				else if ($value != "[general]") 
				{
                                        $select .= "\t\t\t\t\t\t\t<option value=\"" . $value . "\">" . $value . "</option>\n";
                                }
                        }
                }

                $select .= "\t\t\t\t\t\t</select>\n";
                return $select;
        }

	function _lifs_info ()
	{
		require_once('./includes/Helper/Helper.php');

		$lif 		= Helper::getLif();
		$this -> nb_lif = Helper::getLifCount();

		for ($i = 0; $i < $this -> nb_lif; $i++) 
		{
			$this -> ports[$i] = substr($lif[$i], 2, 1);

			switch(substr($lif[$i], 3))
			{
				case "S0":
					$this -> types[$i] = "BRI";
					$this -> start[$i] = "isdn";
					break;
				case "t1e1":
					$this -> t1e1 = true;
				case "E1":
					$this -> types[$i] = "PRI";
					$this -> start[$i] = "isdn";
					break;
				case "S02FXS":
					$this -> types[$i] = "BRIFXS";
					$this -> start[$i] = "isdn/analog";
					break;
				case "FXS":
					$this -> types[$i] = "FXS";
					$this -> start[$i] = "analog";
					break;
				case "FXO":
					$this -> types[$i] = "FXO";
					$this -> start[$i] = "analog";
					break;
				case "GSM":
					$this -> types[$i] = "GSM";
					$this -> start[$i] = "gsm";
					break;
				default:
					$this -> types[$i] = "unknown";
					$this -> start[$i] = "n";
					break;
			}
		}
	}

	function _get_pstn_id_from_port_type ($port_type)
	{
		switch ($port_type)
		{
			default:
			case 'PRI':
				return $this -> pri_wizard;
			case 'BRI':
				return $this -> bri_wizard;
			case 'GSM':
				return $this -> gsm_wizard;
			case 'FXO':
				return $this -> fxo_wizard;
			case 'FXS':
				return $this -> fxs_wizard;
		}
	}

	function _display_simple_select ($forname, $selectname, $infos, $array_options, $tooltiptitle = '')
	{
		$tooltip = ((strlen($tooltiptitle) > 0) ? " data-toogle='tooltip' title='$tooltiptitle'" : '');
		
		$options_str = '';
		foreach ($array_options as $option)
		{
			$options_str .= "\t\t\t\t\t\t\t<option size='40' value='{$option['value']}'{$option['selected']}>{$option['value']}</option>\n";
		}

		return	  "\t\t\t\t<div class='form-group'$tooltip>\n"
			. "\t\t\t\t\t<label class='col-sm-3 control-label' for='$forname'>{$infos['title']}</label>\n"
			. "\t\t\t\t\t<div class='col-sm-8'>\n"
			. "\t\t\t\t\t\t<select class='form-control input-sm' name='$selectname' id='{$infos['id']}'>\n" 
			. $options_str 
			. "\t\t\t\t\t\t</select>\n"
			. "\t\t\t\t\t</div>\n"
			. "\t\t\t\t</div>\n";
	}

	function _display_simple_field ($type, $forname, $inputname, $infos, $value, $tooltip = '')
	{
		if (strlen($tooltip) > 0)
		{
			$tooltip = " data-toogle='tooltip' title='$tooltip'";
		}

		return 	  "\t\t\t\t<div class='form-group'$tooltip>\n"
			. "\t\t\t\t\t<label class='col-sm-3 control-label' for='$forname'>{$infos['title']}</label>\n"
			. "\t\t\t\t\t<div class='col-sm-8'>\n"
			. "\t\t\t\t\t\t<input type='$type' class='form-control input-sm' name='$inputname' id='{$infos['id']}' value='$value'>\n"
			. "\t\t\t\t\t</div>\n"
			. "\t\t\t\t</div>\n";		
	}

	function _display_tones ($group, $forname, $selectname, $infos, $tones, $tooltip = '')
	{
		if (strlen($tooltip) > 0)
		{
			$tooltip = " data-toggle='tooltip' title='$tooltip'";
		}
				
		return	  "\t\t\t\t<div class='form-group' $tooltip>\n"
			. "\t\t\t\t\t<label for='$forname' class='col-sm-3 control-label'>{$infos['title']}</label>\n"
			. "\t\t\t\t\t<div class='col-sm-8'>\n" 
			. $this -> _tones($group, $selectname, $infos['id'], $tones)
			. "\t\t\t\t\t</div>\n"
			. "\t\t\t\t</div>\n";
	}

	function _display_oton ($forname, $infos, $oton, $tooltip = '')
	{
		if (strlen($tooltip) > 0)
		{
			$tooltip = " data-toogle='tooltip' title='$tooltip'";
		}

		if (strlen($oton) > 0)
		{
			$oton="$idtons=$oton";
		}

		return	  "\t\t\t\t<div class='form-group'$tooltip>\n"
			. "\t\t\t\t\t<label class='col-sm-3 control-label' for='$forname'>{$infos['title']}</label>\n"
			. "\t\t\t\t\t<div class='col-sm-8'>\n"
			. tons($infos['id'], $oton) . "\n"
			. "\t\t\t\t\t</div>\n"
			. "\t\t\t\t</div>\n";
	}

	function _display_ports_field ($ba, $ports, $port_type, $forname, $idports, $infos)
	{
		$array_title = array();
		$array_ports = array();

		for ($i = 0; $i < $this -> nb_lif; $i++)
		{
			$array_ports[$i] = '';
			$array_title[$i] = $this -> _display_title_port($ba, $i);

			if (preg_match("#$port_type#", $this -> types[$i]))
			{
				$array_ports[$i] = $this -> _display_ports($ba, $i, $infos['name'], $ports);
			}
		}

		ob_start();
?>
				<div class='form-group ports[]' id='<?php echo $idports; ?>'>
					<label for='<?php echo $forname; ?>' class='col-sm-3 control-label'><?php echo $infos['title']; ?></label>
					<div class='col-sm-8'>
						<div class='left'>
							<div><?php echo $array_title[0]; ?></div>
							<div><?php echo $array_ports[0]; ?></div>
						</div>
						<div class='left' style='margin-left:50px;'>
							<div><?php echo $array_title[1]; ?></div>
							<div><?php echo $array_ports[1]; ?></div>
						</div>
						<div class='left' style='margin-left:50px;'>
							<div><?php echo $array_title[2]; ?></div>
							<div><?php echo $array_ports[2]; ?></div>
						</div>
					</div>
				</div>
<?php
		return ob_get_clean();
	}

	function _display_title_port ($ba, $lif) 
	{
		/*
		 * Generate the title for the port selection
		 * @param beroAri $ba
		 * @param int $lif Line interface number
		 * @return string
		 */

		$query = $ba -> select("select distinct type from isdn where lif='$lif' union select distinct type from analog where lif='$lif' union select distinct type from gsm where lif='$lif' group by type");
		if (sqlite_num_rows($query) == 0) 
		{
			$title = "<b>Li$lif()</b>";
		} 
		else 
		{
			while ($entry = $ba -> fetch_array($query)) 
			{
				$title = "<b>Li$lif({$entry['type']})</b>";
			}
		}

		return $title;
	}

	// TODO: check if $ba can be used before to made a factory reset (when you changed the modules)
	function _display_ports ($ba, $lif, $getbyname, $array_checked_ports) 
	{
		/*
		 * Generates chececkboxes to each port of the line interface $lif
		 * @param beroAri $ba
		 * @param int $lif Line interface number
		 * @return string
		 */

		$query = $ba -> select("select port,port_type from isdn where lif='$lif' union select port,port_type from analog where lif='$lif' union select port,port_type from gsm where lif='$lif' order by port");
		while ($entry = $ba -> fetch_array($query)) 
		{
			$tab .= "<div>Port {$entry['port']}<input type='checkbox' name='". $getbyname ."' value='{$entry['port']}'". (in_array($entry['port'], $array_checked_ports) ? ' checked' : '') ."></div>";
		}

		return $tab;
	}

	function _display_content_pri ($ba, $pri_cfg, $type = 'PRI')
	{
		// init viariables
		$group 		= ( isset($pri_cfg[$this -> pri_group])   ? $pri_cfg[$this -> pri_group] 		: ''					);
		$array_ports 	= ( isset($pri_cfg[$this -> pri_ports])	  ? explode('-', $pri_cfg[$this -> pri_ports])	: array()				);
		$tones		= ( isset($pri_cfg[$this -> pri_tones])	  ? $pri_cfg[$this -> pri_tones]		: ''					);
		$country 	= ( isset($pri_cfg[$this -> pri_country]) ? $pri_cfg[$this -> pri_country]	 	: $ba -> get('international_code')	); 
		$city	 	= ( isset($pri_cfg[$this -> pri_city]) 	  ? $pri_cfg[$this -> pri_city]	 		: $ba -> get('national_code')		); 
		$local	 	= ( isset($pri_cfg[$this -> pri_local])   ? $pri_cfg[$this -> pri_local] 		: '?? $ba -> get() ??'			); 
		$oton	 	= ( isset($pri_cfg[$this -> pri_oton])    ? $pri_cfg[$this -> pri_oton] 		: ''					); 

		// Select t1 or e1
		$t1e1_str = '';
		if ($this -> t1e1)
		{
			$options = array('t1' => array( 'value' => 'T1', 'selected' => ' selected'),
					 'e1' => array( 'value' => 'E1', 'selected' => ''	  ));

			if (isset($pri_cfg[$this -> pri_t1e1]) && strcmp($pri_cfg[$this -> pri_t1e1], 'E1') == 0)
			{
				$options['t1']['selected'] = ''		; 
				$options['e1']['selected'] = ' selected'; 
			}

			$t1e1_str = $this -> _display_simple_select('for-t1e1', WIZARD_T1E1_LABEL_DIS, 'select-t1e1', $this -> pri_t1e1_id[$this -> pri_t1e1]['id']);
		}

		// Select nt ot te
		$options = array('nt' => array( 'value' => 'NT', 'selected' => ' selected'),
				 'te' => array( 'value' => 'TE', 'selected' => ''	  ));

		if (isset($pri_cfg[$this -> pri_ntte]) && strcmp($pri_cfg[$this -> pri_ntte], 'TE') == 0)
		{
			$options['nt']['selected'] = ''	;
			$options['te']['selected'] = ' selected';
		}

		$ntte_str  = $this -> _display_simple_select('for-ntte', 'select-ntte', $this -> pri_ids_array[$this -> pri_ntte], $options, ISDNHW_MODE);

		// ports html string
		$ports_str = $this -> _display_ports_field ($ba, $array_ports , $type, 'for-ports[]', 'id-ports[]', $this -> pri_ids_array[$this -> pri_ports]);

		// tones html string
		$tones_str = $this -> _display_tones($type, 'for-tones', 'select-tones', $this -> pri_ids_array[$this -> pri_tones], $tones);

		// oton html string
		$oton_str  = $this -> _display_oton('for-oton', $this -> pri_ids_array[$this -> pri_oton], $oton);

		// return html string
		return 	  $this -> _display_simple_field('text'	   , 'for-group'  , 'input-group'  , $this -> pri_ids_array[$this -> pri_group]	 , $group	, ISDN_GROUP_NAME)
			. $ports_str
			. $ntte_str
			. $t1e1_str
			. $tones_str
			. $this -> _display_simple_field('text'	   , 'for-country', 'input-country', $this -> pri_ids_array[$this -> pri_country], $country	)
			. $this -> _display_simple_field('text'    , 'for-city'	  , 'input-city'   , $this -> pri_ids_array[$this -> pri_city]	 , $city	)
			. $this -> _display_simple_field('text'    , 'for-local'  , 'input-local'  , $this -> pri_ids_array[$this -> pri_local]  , $local	)
			. $oton_str;
	}

	function _display_content_bri ($ba, $bri_cfg, $type = 'BRI')
	{
		// init viariables
		$group 		= ( isset($bri_cfg[$this -> bri_group])   ? $bri_cfg[$this -> bri_group] 		: ''					);
		$array_ports 	= ( isset($bri_cfg[$this -> bri_ports])	  ? explode('-', $bri_cfg[$this -> bri_ports])	: array()				);
		$tones 		= ( isset($bri_cfg[$this -> bri_tones])	  ? $bri_cfg[$this -> bri_tones]		: ''					);
		$country 	= ( isset($bri_cfg[$this -> bri_country]) ? $bri_cfg[$this -> bri_country]	 	: $ba -> get('international_code')	); 
		$city	 	= ( isset($bri_cfg[$this -> bri_city]) 	  ? $bri_cfg[$this -> bri_city]	 		: $ba -> get('national_code')		); 
		$local	 	= ( isset($bri_cfg[$this -> bri_local])   ? $bri_cfg[$this -> bri_local] 		: '?? $ba -> get() ??'			); 
		$oton	 	= ( isset($bri_cfg[$this -> bri_oton])    ? $bri_cfg[$this -> bri_oton] 		: ''					);  

		// Select ptp or ptmp
		$options = array('ptp'  => array( 'value' => 'PTP' , 'selected' => ' selected'),
				 'ptmp' => array( 'value' => 'PTMP', 'selected' => ''	      ));

		if (isset($bri_cfg[$this -> bri_ptp]) && strcmp($bri_cfg[$this -> bri_ptp], 'PTMP') == 0)
		{
			$options['ptp']['selected']  = ''	  ;
			$options['ptmp']['selected'] = ' selected';
		}

		$ptp_str   = $this -> _display_simple_select('for-ptp', 'select-ptp', $this -> bri_ids_array[$this -> bri_ptp], $options, ISDNHW_MODE);

		// ports html string
		$ports_str = $this -> _display_ports_field ($ba, $array_ports , $type, 'for-ports[]', 'id-ports[]',  $this -> bri_ids_array[$this -> bri_ports]);

		// tones html string
		$tones_str = $this -> _display_tones($type, 'for-tones', 'select-tones', $this -> bri_ids_array[$this -> bri_tones], $tones);

		// oton html string
		$oton_str  = $this -> _display_oton('for-oton', $this -> bri_ids_array[$this -> bri_oton], $oton);

		// return html string
		return 	  $this -> _display_simple_field('text'	   , 'for-group'  , 'input-group'  , $this -> bri_ids_array[$this -> bri_group]	 , $group	, ISDN_GROUP_NAME)
			. $ports_str
			. $ptp_str
			. $tones_str
			. $this -> _display_simple_field('text'	   , 'for-country', 'input-country', $this -> bri_ids_array[$this -> bri_country], $country	)
			. $this -> _display_simple_field('text'    , 'for-city'	  , 'input-city'   , $this -> bri_ids_array[$this -> bri_city]	 , $city	)
			. $this -> _display_simple_field('text'    , 'for-local'  , 'input-local'  , $this -> bri_ids_array[$this -> bri_local]  , $local	)
			. $oton_str;
	}	

	function _display_content_gsm ($ba, $gsm_cfg, $type = 'GSM')
	{
		$html_str = '';

		return $html_str;
	}

	function _display_content_fxo ($ba, $fxo_cfg, $type = 'FXO')
	{
		// init variables
		$group 		= ( isset($fxo_cfg[$this -> fxo_group])   ? $fxo_cfg[$this -> fxo_group] 		: ''		);
		$array_ports 	= ( isset($fxo_cfg[$this -> fxo_ports])	  ? explode('-', $fxo_cfg[$this -> fxo_ports])	: array()	);
		$tones		= ( isset($fxo_cfg[$this -> fxo_tones])	  ? $fxo_cfg[$this -> fxo_tones]		: ''		);

		// ports html string
		$ports_str = $this -> _display_ports_field ($ba, $array_ports , $type, 'for-ports[]', 'id-ports[]', $this -> fxo_ids_array[$this -> fxo_ports]);

		// tones html string
		$tones_str = $this -> _display_tones($type, 'for-tones', 'select-tones', $this -> fxo_ids_array[$this -> fxo_tones], $tones);

		return 	  $this -> _display_simple_field('text', 'for-group', 'input-group', $this -> fxo_ids_array[$this -> fxo_group], $group	, ISDN_GROUP_NAME)
			. $ports_str 
			. $tones_str;
	}

	function _display_content_fxs ($ba, $fxs_cfg, $type = 'FXS')
	{
		// init variables
		$group 		= ( isset($fxs_cfg[$this -> fxs_group])   ? $fxs_cfg[$this -> fxs_group] 		: ''		);
		$array_ports 	= ( isset($fxs_cfg[$this -> fxs_ports])	  ? explode('-', $fxs_cfg[$this -> fxs_ports])	: array()	);
		$tones		= ( isset($fxs_cfg[$this -> fxs_tones])	  ? $fxs_cfg[$this -> fxs_tones]		: ''		);

		// ports html string
		$ports_str = $this -> _display_ports_field ($ba, $array_ports , $type, 'for-ports[]', 'id-ports[]', $this -> fxs_ids_array[$this -> fxs_ports]);

		// tones html string
		$tones_str = $this -> _display_tones($type, 'for-tones', 'select-tones', $this -> fxs_ids_array[$this -> fxs_tones], $tones);

		// TODO: upload file

		// return html string
		return 	  $this -> _display_simple_field('text', 'for-group', 'input-group', $this -> fxs_ids_array[$this -> fxs_group], $group	, ISDN_GROUP_NAME)
			. $ports_str 
			. $tones_str;
	}

	function _display_parameters_value ($array_names, $array_parameters)
	{
		$html_str = '';
	
		foreach ($array_names as $id_para => $name_para)
		{
			if (isset($array_parameters[$id_para]) && strlen($array_parameters[$id_para]) > 0)
			{
				$html_str .= "\t\t\t\t$name_para = {$array_parameters[$id_para]} <br/>";
			}
		}
	
		return $html_str . "\n";
	}

	// public
	function get_ids_array ()
	{
		return $this -> ids_array;
	}

	// TODO: must be updated for BRI/FXS
	function get_content_modal ($ba, $pstn_cfg)
	{
		$html_str = '';

		$query = $ba -> select("select distinct port_type,type from isdn union select distinct port_type, type from analog union select distinct port_type, type from gsm group by port_type");	
		while ($entry = $ba -> fetch_array($query))
		{
			$type      = $entry['port_type'];
			$name      = $this -> ids_array[$this -> pstn_header]['name'];
			$checked   = ((isset($pstn_cfg['PSTN_header']) && $pstn_cfg['PSTN_header'] == "$type-") ? ' checked' : '');
			$html_str .= "\t\t\t\t\t<input type='radio' id='id$type' value='$type' name='$name' onclick=\"show_port('$type');\"$checked>$type\n";
		}

		ob_start();
?>
			<div class='form-group group' id='PSTN-Header'>
				<label for='for-pstn' class='col-sm-6 control-label'><?php echo WIZARD_PSTN_NETWORK_GROUP_DIS; ?></label>
				<div class='col-sm-5'>
<?php
		$html_str = 	ob_get_clean()
				. $html_str;

		ob_start();
?>
				</div>
			</div>
<?php
		$html_str .= ob_get_clean();

		// IDSN PRI 
		if (in_array('PRI', $this -> types))
		{
			$html_str .= 	  "\t\t\t<div id='". $this -> pri_wizard ."'>\n"
					. $this -> _display_content_pri($ba, $pstn_cfg)
					. "\t\t\t</div>\n";
		}

		// IDSN BRI
		if (in_array('BRI', $this -> types) || in_array('BRI/FXS', $this -> types))
		{
			$html_str .= 	  "\t\t\t<div id='". $this -> bri_wizard ."'>\n"
					. $this -> _display_content_bri($ba, $pstn_cfg)
					. "\t\t\t</div>\n";		
		}

		// GSM
		if (in_array('GSM', $this -> types))
		{
			$html_str .=	  "\t\t\t<div id='". $this -> gsm_wizard ."'>\n"
					. $this -> _display_content_gsm($ba, $pstn_cfg)
					. "\t\t\t</div>\n";
		}

		// FX0
		if (in_array('FXO', $this -> types))
		{
			$html_str .= 	  "\t\t\t<div id='". $this -> fxo_wizard ."'>\n"
					. $this -> _display_content_fxo($ba, $pstn_cfg)
					. "\t\t\t</div>\n";
		}

		// FXS
		if (in_array('FXS', $this -> types) || in_array('BRI/FXS', $this -> types))
		{
			$html_str .= 	  "\t\t\t<div id='". $this -> fxs_wizard ."'>\n"
					. $this -> _display_content_fxs($ba, $pstn_cfg)
					. "\t\t\t</div>\n";
		}

		return $html_str;
	}

	function get_javascript_code ($type)
	{
		$loading_port = '';
		$show_port    =   "\tfunction show_port(port_type)\n"
				. "\t{\n";

		foreach ($this -> types as $port_type)
		{
			$id = $this -> _get_pstn_id_from_port_type($port_type);

			$loading_port .= "\t$('#$id').". ((preg_match("#$port_type#", $type)) ? 'show()' : 'hide()' ) .";\n";

			$array_hide = array_diff($this -> types, array($port_type));

			$show_port .= 	  "\t\tif (port_type === '$port_type')\n"
					. "\t\t{\n"
					. "\t\t\t$('#$id').show();\n";

			foreach ($array_hide as $hide_port_type)
			{
				$show_port .= "\t\t\t$('#". $this -> _get_pstn_id_from_port_type($hide_port_type) ."').hide();\n";
			}

			$show_port .= "\t\t}\n";
		}

		$show_port .= "\t}\n";

		ob_start();
?>
<script type="text/javascript">
<?php echo $loading_port . "\n" . $show_port; ?>
</script>
<?php
		return ob_get_clean();	
	}

	function organize_settings ($pstn_settings)
	{ 
		$settings['type'] = str_replace("-", "", $pstn_settings['PSTN_header']);
		unset($pstn_settings['PSTN_header']);
	
		foreach ($pstn_settings as $parameter => $value)
		{
			if (preg_match("#{$settings['type']}#", $parameter))
			{
				$settings[str_replace($settings['type']."_", "", $parameter)] = $value;
			}
		}

		return $settings;
	}

	function get_summary_settings($pstn_settings)
	{
		$settings = '';

		foreach ($pstn_settings as $parameter => $value)
		{
			$settings .= "$parameter = $value <br/>";
		}

		return $settings;
	}
}

?>
